from __future__ import division
import sys
sys.path.append('/home/fabee/code/natter')
sys.path.append('/home/fabee/code/')
from fabee.Plotting import *
from natter.Distributions import LpSphericallySymmetric, Gamma, ChiP, Truncated
from natter.DataModule import *
from numpy import *
from matplotlib.pyplot import *

pin = LpSphericallySymmetric(n=2,p=2,rp=Gamma(u=1))

r = linspace(-3,3,1000)
X,Y = meshgrid(r,r)

x = vstack((X.ravel(),Y.ravel()))
dat = pin.sample(10000)
dat.X = dat.X/atleast_2d(dat.var()).T
pin.estimate(dat)

dat = Data(x)

P = pin.loglik(dat)

pout =  LpSphericallySymmetric(n=2,p=2,rp=ChiP(n=2,p=2))
tmp =  Truncated(q=ChiP(n=2,p=2),a=0,b=ChiP(n=2,p=2).ppf(.6).X[0,0])
kappa = ChiP(n=2,p=2).ppf(.9).X[0,0]
pout2 =  LpSphericallySymmetric(n=2,p=2,rp=Truncated(q=ChiP(n=2,p=2),a=0,b=kappa))


Q = pout.loglik(dat)
Q2 = pout2.loglik(dat)


fig = figure(figsize=(10,10))
ax = fig.add_axes([.0,.3,.4,.4])
CS = ax.contour(X,Y,P.reshape(X.shape),arange(-6.5,.5,.5))
clabel(CS, fontsize=9, inline=1)
ax.axis('off')

ax = fig.add_axes([.1,.75,.2,.2])
t = linspace(0,sqrt(18),1000)
pp = pin['rp'].pdf(Data(t))
t = hstack((0,t,t[-1]))
pp = hstack((0,pp,0))
ax.fill(t, pp,'-k',facecolor=(.7,.7,.7))
ax.set_xticks([])
ax.set_yticks([])
ax.set_xlim(0,sqrt(18))
box_off(ax)

ax = fig.add_axes([.8,.55,.15,.15])
t = linspace(0,sqrt(18),1000)
pp = pout2['rp'].pdf(Data(t))
ind = where(1-isnan(pp))[0]
t = t[ind]
pp = pp[ind]
t = hstack((0,t,kappa))
pp = hstack((0,pp,0))

ax.fill(t, pp,'-k',facecolor=(.7,.7,.7))
ax.set_xticks([])
ax.set_yticks([])
ax.set_xlim(0,sqrt(18))
box_off(ax)


ax = fig.add_axes([.8,.35,.15,.15])
t = linspace(0,sqrt(18),1000)
pp = pout['rp'].pdf(Data(t))
t = hstack((0,t,t[-1]))
pp = hstack((0,pp,0))
ax.fill(t, pp,'-k',facecolor=(.7,.7,.7))
ax.set_xticks([])
ax.set_yticks([])
ax.set_xlim(0,sqrt(18))
box_off(ax)



ax = fig.add_axes([.6,.0,.3,.3])
CS = ax.contour(X,Y,Q.reshape(X.shape),arange(-6.5,.5,.5))
clabel(CS, fontsize=9, inline=1)
ax.axis('off')

ax = fig.add_axes([.6,.7,.3,.3])
CS = ax.contour(X,Y,Q2.reshape(X.shape),arange(-6.5,.5,.5))
clabel(CS, fontsize=9, inline=1)

t = linspace(0,2*pi,1000)
ax.plot(kappa*cos(t),kappa*sin(t),'--k')
ax.axis('off')


fig.savefig('RF.pdf')


show()
