from __future__ import division
import sys
sys.path.insert(1,'/home/fabee/code/natter')
sys.path.insert(1,'/home/fabee/code')
 
 
from fabee.Plotting import *
from fabee import MWJournal
from numpy import *
 
 
from natter.Auxiliary.Entropy import marginalEntropy, LpEntropy
from natter.DataModule import Data
from natter.Distributions import Gamma, NakaRushton, ChiP, Truncated, LpSphericallySymmetric
 
from matplotlib.pyplot import *
 
 
 
################################################################################    
 
 

# -- set a few variables
n= 100.0 # dimensionality of the filter responses
m = 100000
 
fig = figure()
ax = fig.add_axes([.2,.2,.75,.7])
disjoint_axes(ax)
 
for pp in [1.5,2.,3.]:
    # obtain kappa
    pChi = ChiP(n=n,p=pp)
    quants = linspace(.01,1-.01,10)
    kappas = squeeze(pChi.ppf(quants).X)
    MI = []
    # load different models and compute estimates
    for kappa in kappas:
        pChiT = Truncated(q=pChi,a=0.0,b=kappa)
        p = LpSphericallySymmetric(n=n,rp=pChiT,p=pp)
        dat = p.sample(m)
        margEntr = marginalEntropy(dat)
        jointEntr = LpEntropy(dat,pp)
        MI.append(mean(margEntr) - jointEntr/n)
 
 
 
    ax.loglog(quants, MI,label=r'$p=%.1f$' % (pp,))
 
leg = ax.legend(frameon=False,loc=6)
ax.set_xlabel('truncation threshold [quantile]')
ax.set_ylabel('multi-information [nats/dimension]')

fig.savefig('monotonicity2.pdf')
# ax2.plot(quants, MI, 'b-')
 
# ax1.set_xlabel('truncation thresholds')
# ax2.set_xlabel('quantiles')
# ax1.set_ylabel('MI [nats/comp], n=%i, m=%i' % (n,m))
 
